#define CONFIGURE_INIT
#include "system.h"
#include <signal.h>
#include <errno.h>
#include <stdlib.h>
#include <assert.h>
#include <stdio.h>
#include <sched.h>

#include "pool.h"
#include "returncode.h"


int sres=1000;
void* short_request(void* arg) {
   printf("Complete short request\n"); 
   return &sres;
}
int lres=1001;
void* long_request(void* arg) {
   struct timespec wait;
   wait.tv_nsec=0;
   wait.tv_sec=5;
   nanosleep(&wait,NULL);
   printf("Complete long request\n"); 
   return &lres;
}

 pthread_pool_attr_t attr;
 pthread_pool_t p;
 pthread_pool_request_t request_id [2];

 // Receive responses
 //
 void receive_response() {
   int i;
   for (i=0; i<2; i++) {
     int* result=(int*)pthread_pool_response(&p, request_id[i]);
     if(result==NULL)
       printf("pthread_pool_response init.c");

     printf("result = %d \n", *result);
   }
 }
 


void* POSIX_Init(void *argument)
{

 int status;

 pthread_pool_attr_init(&attr);
 pthread_pool_attr_setpriority(&attr, 100);
 pthread_pool_attr_setsize(&attr, 2);

 status=pthread_pool_init(&p, attr);
 if(status!=0)
     returncode("pthread_pool_init init.c",status);
 
 // Send requests
 status=pthread_pool_request(&p, long_request, NULL, &request_id[1]);
 if(status!=0)
     returncode("pthread_pool_request init.c",status);

 status=pthread_pool_request(&p, short_request, NULL, &request_id[0]);
 if(status!=0)
     returncode("pthread_pool_request init.c",status);
 

 // Read responses 
 receive_response();


 status=pthread_pool_request(&p, short_request, NULL, &request_id[0]);

 if(status!=0)
     returncode("pthread_pool_request init.c",status);

 status=pthread_pool_request(&p, short_request, NULL, &request_id[1]);
 if(status!=0)
     returncode("pthread_pool_request init.c",status);
 

 receive_response();


 pthread_pool_destroy(&p);
 pthread_exit(NULL);
 
 return 0; 

}



