
#include <sched.h>
#include <semaphore.h>

#ifndef  POOL_H
#define  POOL_H yes

#define CONFIGURE_MAXIMUM_POOL_SIZE    10


typedef void* (*request_func_t) (void*);

typedef int pthread_pool_request_t;

typedef struct pthread_pool_attr_t {
  int priority;
  int size;
} pthread_pool_attr_t;


typedef struct pthread_pool_t{
  pthread_mutex_t sc;
  sem_t           waitfor_request[CONFIGURE_MAXIMUM_POOL_SIZE];
  sem_t           response_isready[CONFIGURE_MAXIMUM_POOL_SIZE];
  void*           results[CONFIGURE_MAXIMUM_POOL_SIZE];
  // Extend the struct if necessary
} pthread_pool_t;



extern int pthread_pool_attr_init(struct pthread_pool_attr_t *a);
extern int pthread_pool_attr_setpriority(struct pthread_pool_attr_t *a, int prio);
extern int pthread_pool_attr_getpriority(struct pthread_pool_attr_t a);
extern int pthread_pool_attr_setsize(struct pthread_pool_attr_t *a, int s);
extern int pthread_pool_attr_getsize(struct pthread_pool_attr_t a);
extern int pthread_pool_attr_destroy(struct pthread_pool_attr_t *a);


extern int   pthread_pool_init(struct pthread_pool_t* r, struct pthread_pool_attr_t a);
extern int   pthread_pool_request(struct pthread_pool_t* r,
  request_func_t func, void* arg, pthread_pool_request_t* id);
extern void* pthread_pool_response(struct pthread_pool_t* r, pthread_pool_request_t id);
extern int   pthread_request_status(struct pthread_pool_t* r, pthread_pool_request_t id);
extern int   pthread_pool_destroy(struct pthread_pool_t* r);



#endif				


